/* morfeusz-gen.h
   Copyright © 2008 by Marcin Woliński


   C language interface for morphological generator Morfeusz SGJP
   (preliminary version!)

*/

#ifndef __MORFEUSZ_GEN_H__
#define __MORFEUSZ_GEN_H__

#ifndef __WIN32
#define DLLIMPORT
#else
/* A Windows system.  Need to define DLLIMPORT. */
#if BUILDING_MORFEUSZ
#  define DLLIMPORT __declspec (dllexport)
#else
#  define DLLIMPORT __declspec (dllimport)
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  struct _morfeusz_form {
    char *word;
    const char *tag;
  };
  typedef struct _morfeusz_form morfeusz_form;

  /* This function generates all inflected forms of a given lexeme.
     Input: lemma of the lexeme, its homonym number, grammatical class
     (POS).  Output: the returned value is a pointer to a table of
     forms, the number of forms generated is assigned to numforms (<=0
     signals an error).

     The memory for the returned table is managed by Morfeusz.  The
     result is valid until the next call to morfeusz_generate, then it
     is recycled.
   */

  DLLIMPORT morfeusz_form *morfeusz_generate(char *lemma, char homonym,
                                             char *pos,
                                             int *numforms
                                             );


#ifdef __cplusplus
} /* extern C */
#endif /* __cplusplus */

#endif /* __MORFEUSZ_GEN_H__ */
